<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__network__buffer_8c" kind="file" language="C++">
    <compoundname>cy_network_buffer.c</compoundname>
    <includes local="no">stdlib.h</includes>
    <includes local="yes" refid="cy__network__buffer_8h">cy_network_buffer.h</includes>
    <includes local="yes">cy_utils.h</includes>
    <includes local="yes">lwip/pbuf.h</includes>
    <includes local="yes">lwip/memp.h</includes>
    <incdepgraph>
      <node id="1">
        <label>stdlib.h</label>
      </node>
      <node id="4">
        <label>lwip/memp.h</label>
      </node>
      <node id="0">
        <label>cy_network_buffer.c</label>
        <link refid="cy__network__buffer_8c" />
        <childnode refid="1" relation="include">
        </childnode>
        <childnode refid="2" relation="include">
        </childnode>
        <childnode refid="3" relation="include">
        </childnode>
        <childnode refid="4" relation="include">
        </childnode>
      </node>
      <node id="3">
        <label>lwip/pbuf.h</label>
      </node>
      <node id="2">
        <label>cy_utils.h</label>
      </node>
    </incdepgraph>
      <sectiondef kind="define">
      <memberdef id="cy__network__buffer_8c_1ae2b22da2fd3683faf7b150e3848d566e" kind="define" prot="public" static="no">
        <name>SDIO_BLOCK_SIZE</name>
        <initializer>(64U)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="32" column="10" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" line="32" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1gacdcb08de31442a9e5d1f32b4e99a2de3" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>whd_result_t</type>
        <definition>whd_result_t cy_host_buffer_get</definition>
        <argsstring>(whd_buffer_t *buffer, whd_buffer_dir_t direction, unsigned short size, unsigned long timeout_ms)</argsstring>
        <name>cy_host_buffer_get</name>
        <param>
          <type>whd_buffer_t *</type>
          <declname>buffer</declname>
        </param>
        <param>
          <type>whd_buffer_dir_t</type>
          <declname>direction</declname>
        </param>
        <param>
          <type>unsigned short</type>
          <declname>size</declname>
        </param>
        <param>
          <type>unsigned long</type>
          <declname>timeout_ms</declname>
        </param>
        <briefdescription>
<para>Allocates a packet buffer. </para>        </briefdescription>
        <detaileddescription>
<para>Attempts to allocate a packet buffer of the size requested. It can do this by allocating a pre-existing packet from a pool, using a static buffer, or by dynamically allocating memory. The method of allocation does not concern WHD, however it must match the way the network stack expects packet buffers to be allocated. Usually WHD requires packet of size of WHD_LINK_MTU which includes the MTU. Refer to whd_types.h to find the size of WHD_LINK_MTU.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: A pointer which receives the allocated packet buffer handle </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>direction</parametername>
</parameternamelist>
<parameterdescription>
<para>: Indicates transmit/receive direction that the packet buffer is used for. This may be needed if tx/rx pools are separate. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>size</parametername>
</parameternamelist>
<parameterdescription>
<para>: The number of bytes to allocate. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>timeout_ms</parametername>
</parameternamelist>
<parameterdescription>
<para>Time to wait for a packet buffer to be available</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>: CY_RSLT_SUCCESS or WHD_BUFFER_ALLOC_FAIL if the buffer could not be allocated </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="61" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="34" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" line="34" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1gaac05ad889f09b6e8ef43503ba475a21f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cy_buffer_release</definition>
        <argsstring>(whd_buffer_t buffer, whd_buffer_dir_t direction)</argsstring>
        <name>cy_buffer_release</name>
        <param>
          <type>whd_buffer_t</type>
          <declname>buffer</declname>
        </param>
        <param>
          <type>whd_buffer_dir_t</type>
          <declname>direction</declname>
        </param>
        <briefdescription>
<para>Releases a packet buffer. </para>        </briefdescription>
        <detaileddescription>
<para>This function is used by WHD to indicate that it no longer requires a packet buffer. The buffer can then be released back into a pool for reuse, or the dynamically allocated memory can be freed, according to how the packet was allocated. Returns void since WHD cannot do anything about failures</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: The handle of the packet buffer to be released </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>direction</parametername>
</parameternamelist>
<parameterdescription>
<para>: Indicates transmit/receive direction that the packet buffer has been used for. This might be needed if tx/rx pools are separate. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="67" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="63" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" line="63" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1ga782b3a560466f80c438e5c306107eeb1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint8_t *</type>
        <definition>uint8_t* cy_buffer_get_current_piece_data_pointer</definition>
        <argsstring>(whd_buffer_t buffer)</argsstring>
        <name>cy_buffer_get_current_piece_data_pointer</name>
        <param>
          <type>whd_buffer_t</type>
          <declname>buffer</declname>
        </param>
        <briefdescription>
<para>Retrieves the current pointer of a packet buffer. </para>        </briefdescription>
        <detaileddescription>
<para>Since packet buffers usually need to be created with space at the front for additional headers, this function allows WHD to get the current 'front' location pointer.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: The handle of the packet buffer whose pointer is to be retrieved</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>: The packet buffer's current pointer. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="74" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="69" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" line="69" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1ga9890010d1a7246a440477d47dc2c7b2b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint16_t</type>
        <definition>uint16_t cy_buffer_get_current_piece_size</definition>
        <argsstring>(whd_buffer_t buffer)</argsstring>
        <name>cy_buffer_get_current_piece_size</name>
        <param>
          <type>whd_buffer_t</type>
          <declname>buffer</declname>
        </param>
        <briefdescription>
<para>Retrieves the size of a packet buffer. </para>        </briefdescription>
        <detaileddescription>
<para>Since packet buffers usually need to be created with space at the front for additional headers, the memory block used to contain a packet buffer will often be larger than the current size of the packet buffer data. This function allows WHD to retrieve the current size of a packet buffer's data.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: The handle of the packet buffer whose size is to be retrieved</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>: The size of the packet buffer. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="81" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="76" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" line="76" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1gafd58907304a573df160ea12c97199c2e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>whd_result_t</type>
        <definition>whd_result_t cy_buffer_set_size</definition>
        <argsstring>(whd_buffer_t buffer, unsigned short size)</argsstring>
        <name>cy_buffer_set_size</name>
        <param>
          <type>whd_buffer_t</type>
          <declname>buffer</declname>
        </param>
        <param>
          <type>unsigned short</type>
          <declname>size</declname>
        </param>
        <briefdescription>
<para>Sets the current size of a WHD packet. </para>        </briefdescription>
        <detaileddescription>
<para>This function sets the current length of a WHD packet buffer</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: The packet to be modified </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>size</parametername>
</parameternamelist>
<parameterdescription>
<para>: The new size of the packet buffer</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>: CY_RSLT_SUCCESS or WHD_PMK_WRONG_LENGTH if the requested size is not valid </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="97" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="83" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" line="83" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1gaa284f33e6c96712370302d61d4b7cd58" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>whd_result_t</type>
        <definition>whd_result_t cy_buffer_add_remove_at_front</definition>
        <argsstring>(whd_buffer_t *buffer, int32_t add_remove_amount)</argsstring>
        <name>cy_buffer_add_remove_at_front</name>
        <param>
          <type>whd_buffer_t *</type>
          <declname>buffer</declname>
        </param>
        <param>
          <type>int32_t</type>
          <declname>add_remove_amount</declname>
        </param>
        <briefdescription>
<para>Moves the current pointer of a packet buffer. </para>        </briefdescription>
        <detaileddescription>
<para>Since packet buffers usually need to be created with space at the front for additional headers, this function allows WHD to move the current 'front' location pointer so that it has space to add headers to transmit packets, and so that the network stack does not see the internal WHD headers on received packets.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: A pointer to the handle of the current packet buffer for which the current pointer will be moved. On return this may contain a pointer to a newly allocated packet buffer which has been daisy chained to the front of the given one. This would be the case if the given packet buffer didn't have enough space at the front. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>add_remove_amount</parametername>
</parameternamelist>
<parameterdescription>
<para>: This is the number of bytes to move the current pointer of the packet buffer - a negative value increases the space for headers at the front of the packet, a positive value decreases the space.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>: CY_RSLT_SUCCESS or WHD_PMK_WRONG_LENGTH if the added amount is outside the size of the buffer </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="110" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="99" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" line="99" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Basic set of APIs for dealing with network packet buffers. </para>    </briefdescription>
    <detaileddescription>
<para>This is used by WHD for relaying data between the network stack and the connectivity chip.</para><para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="26"><highlight class="preprocessor">#include<sp />&lt;stdlib.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="27"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_network_buffer.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_utils.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"lwip/pbuf.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"lwip/memp.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /><highlight class="preprocessor">#define<sp /><sp />SDIO_BLOCK_SIZE<sp />(64U)</highlight><highlight class="normal" /></codeline>
<codeline lineno="33"><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal">whd_result_t<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1gacdcb08de31442a9e5d1f32b4e99a2de3">cy_host_buffer_get</ref>(whd_buffer_t<sp />*buffer,<sp />whd_buffer_dir_t<sp />direction,<sp /></highlight><highlight class="keywordtype">unsigned</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">short</highlight><highlight class="normal"><sp />size,<sp /></highlight><highlight class="keywordtype">unsigned</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">long</highlight><highlight class="normal"><sp />timeout_ms)</highlight></codeline>
<codeline lineno="35"><highlight class="normal">{</highlight></codeline>
<codeline lineno="36"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(<sp />direction<sp />);</highlight></codeline>
<codeline lineno="37"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(<sp />timeout_ms<sp />);</highlight></codeline>
<codeline lineno="38"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">pbuf<sp />*p<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="39"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />(<sp />direction<sp />==<sp />WHD_NETWORK_TX)<sp />&amp;&amp;<sp />(<sp />size<sp />&lt;=<sp />PBUF_POOL_BUFSIZE<sp />)<sp />)</highlight></codeline>
<codeline lineno="40"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="41"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />p<sp />=<sp />pbuf_alloc(PBUF_RAW,<sp />size,<sp />PBUF_POOL);</highlight></codeline>
<codeline lineno="42"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="43"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="44"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="45"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />p<sp />=<sp />pbuf_alloc(PBUF_RAW,<sp />size+SDIO_BLOCK_SIZE,<sp />PBUF_RAM);</highlight></codeline>
<codeline lineno="46"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />p<sp />!=<sp />NULL<sp />)</highlight></codeline>
<codeline lineno="47"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="48"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />p-&gt;len<sp />=<sp />size;</highlight></codeline>
<codeline lineno="49"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />p-&gt;tot_len<sp />-=<sp /><sp />SDIO_BLOCK_SIZE;</highlight></codeline>
<codeline lineno="50"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="51"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="52"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(p<sp />!=<sp />NULL<sp />)</highlight></codeline>
<codeline lineno="53"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="54"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*buffer<sp />=<sp />p;</highlight></codeline>
<codeline lineno="55"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />WHD_SUCCESS;</highlight></codeline>
<codeline lineno="56"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="57"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="59"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />WHD_BUFFER_ALLOC_FAIL;</highlight></codeline>
<codeline lineno="60"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="61"><highlight class="normal">}</highlight></codeline>
<codeline lineno="62"><highlight class="normal" /></codeline>
<codeline lineno="63"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1gaac05ad889f09b6e8ef43503ba475a21f">cy_buffer_release</ref>(whd_buffer_t<sp />buffer,<sp />whd_buffer_dir_t<sp />direction)</highlight></codeline>
<codeline lineno="64"><highlight class="normal">{</highlight></codeline>
<codeline lineno="65"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(<sp />direction<sp />);</highlight></codeline>
<codeline lineno="66"><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp />pbuf_free(<sp />(</highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp />pbuf<sp />*)buffer<sp />);</highlight></codeline>
<codeline lineno="67"><highlight class="normal">}</highlight></codeline>
<codeline lineno="68"><highlight class="normal" /></codeline>
<codeline lineno="69"><highlight class="normal">uint8_t<sp />*<ref kindref="member" refid="group__group__bsp__network__buffer_1ga782b3a560466f80c438e5c306107eeb1">cy_buffer_get_current_piece_data_pointer</ref>(whd_buffer_t<sp />buffer)</highlight></codeline>
<codeline lineno="70"><highlight class="normal">{</highlight></codeline>
<codeline lineno="71"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(buffer<sp />!=<sp />NULL);</highlight></codeline>
<codeline lineno="72"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">pbuf<sp />*pbuffer=<sp />(</highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">pbuf*)<sp />buffer;</highlight></codeline>
<codeline lineno="73"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(uint8_t*)<sp />pbuffer-&gt;payload;</highlight></codeline>
<codeline lineno="74"><highlight class="normal">}</highlight></codeline>
<codeline lineno="75"><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal">uint16_t<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1ga9890010d1a7246a440477d47dc2c7b2b">cy_buffer_get_current_piece_size</ref>(whd_buffer_t<sp />buffer)</highlight></codeline>
<codeline lineno="77"><highlight class="normal">{</highlight></codeline>
<codeline lineno="78"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(buffer<sp />!=<sp />NULL);</highlight></codeline>
<codeline lineno="79"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">pbuf<sp />*pbuffer<sp />=<sp />(</highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">pbuf*)<sp />buffer;</highlight></codeline>
<codeline lineno="80"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(uint16_t)<sp />pbuffer-&gt;len;</highlight></codeline>
<codeline lineno="81"><highlight class="normal">}</highlight></codeline>
<codeline lineno="82"><highlight class="normal" /></codeline>
<codeline lineno="83"><highlight class="normal">whd_result_t<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1gafd58907304a573df160ea12c97199c2e">cy_buffer_set_size</ref>(whd_buffer_t<sp />buffer,<sp /></highlight><highlight class="keywordtype">unsigned</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">short</highlight><highlight class="normal"><sp />size)</highlight></codeline>
<codeline lineno="84"><highlight class="normal">{</highlight></codeline>
<codeline lineno="85"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(buffer<sp />!=<sp />NULL);</highlight></codeline>
<codeline lineno="86"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">pbuf<sp />*<sp />pbuffer<sp />=<sp />(</highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">pbuf<sp />*)<sp />buffer;</highlight></codeline>
<codeline lineno="87"><highlight class="normal" /></codeline>
<codeline lineno="88"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />size<sp />&gt;<sp />(</highlight><highlight class="keywordtype">unsigned</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">short</highlight><highlight class="normal">)<sp />WHD_LINK_MTU<sp /><sp />+<sp />LWIP_MEM_ALIGN_SIZE(LWIP_MEM_ALIGN_SIZE(</highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(</highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp />pbuf)))<sp />+<sp />LWIP_MEM_ALIGN_SIZE(size)<sp />)</highlight></codeline>
<codeline lineno="89"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="90"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />WHD_PMK_WRONG_LENGTH;</highlight></codeline>
<codeline lineno="91"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="92"><highlight class="normal" /></codeline>
<codeline lineno="93"><highlight class="normal"><sp /><sp /><sp /><sp />pbuffer-&gt;tot_len<sp />=<sp />size;</highlight></codeline>
<codeline lineno="94"><highlight class="normal"><sp /><sp /><sp /><sp />pbuffer-&gt;len<sp />=<sp />size;</highlight></codeline>
<codeline lineno="95"><highlight class="normal" /></codeline>
<codeline lineno="96"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />CY_RSLT_SUCCESS;</highlight></codeline>
<codeline lineno="97"><highlight class="normal">}</highlight></codeline>
<codeline lineno="98"><highlight class="normal" /></codeline>
<codeline lineno="99"><highlight class="normal">whd_result_t<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1gaa284f33e6c96712370302d61d4b7cd58">cy_buffer_add_remove_at_front</ref>(whd_buffer_t<sp />*buffer,<sp />int32_t<sp />add_remove_amount)</highlight></codeline>
<codeline lineno="100"><highlight class="normal">{</highlight></codeline>
<codeline lineno="101"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(buffer<sp />!=<sp />NULL);</highlight></codeline>
<codeline lineno="102"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">pbuf<sp />**pbuffer<sp />=<sp />(</highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">pbuf**)<sp />buffer;</highlight></codeline>
<codeline lineno="103"><highlight class="normal" /></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />(u8_t)<sp />0<sp />!=<sp />pbuf_header(<sp />*pbuffer,<sp />(<sp />s16_t<sp />)(<sp />-add_remove_amount<sp />)<sp />)<sp />)</highlight></codeline>
<codeline lineno="105"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="106"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />WHD_PMK_WRONG_LENGTH;</highlight></codeline>
<codeline lineno="107"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="108"><highlight class="normal" /></codeline>
<codeline lineno="109"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />WHD_SUCCESS;</highlight></codeline>
<codeline lineno="110"><highlight class="normal">}</highlight></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" />
  </compounddef>
</doxygen>